/* 
 * wildsms.com SMS utility
 * (c) 2001 Safety, mdanielsson@trustlab.com
 *
 * Minor changes to make use of getopt() by noah (tm[at]ns2.crw.se])
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <ctype.h>
#include <unistd.h>
#include "color.h"

#define PORT 80
#define HOSTNAME "wildsms.com"
#define NUM 10
#define LEN 160

int sendsms(char *to, char *from, char *uid, char *message, char *password);
int check_balance(char *uid, char *password);
int credits(char *str);
void split(char *msg);
void draw(void);
void usage(void);


char msgs[NUM][LEN];
int amount = 1;

int
main(int argc, char **argv)
{

	char *to = NULL;
	char *from = NULL;
	char *pin = NULL;
	char *message = NULL;
	char *uid = NULL;
	int checkbal = 0, i, n;

	if(argc < 6)
		usage();

	while((n = getopt(argc, argv, "f:t:m:u:p:b")) != -1) {
		switch(n) {
			case 'p':
			pin = optarg;
			break;

			case 'u':
			uid = optarg;
			break;

			case 'm':
			message = optarg;
			break;

			case 'f':
			from = optarg;
			break;

			case 't':
			to = optarg;
			break;

			case 'b':
			checkbal++;
			break;

			default:
			printf("Unknown option\n");
			usage();
		}
	}


	if(!uid || !pin) {
		fprintf(stderr, "You must specify username AND pin\n");
		exit(-1);
	}

	if(checkbal) {
		check_balance(uid, pin);
		return 0;
	}

	if(!message || !to || !from) {
		fprintf(stderr, "You forgot to specify message, to# or from#\n");
		exit(-1);
	}

	memset(msgs, 0, sizeof(char) * (NUM * LEN));
	split(message);

	for (i = 0; i >= 0; i++) {
		  if (!msgs[i][0])
			  break;

		  sendsms(to, from, uid, msgs[i], pin);
	}

	printf("\n");
	check_balance(uid, pin);
	
	return 1;
}


int
sendsms(char *to, char *from, char *uid, char *message, char *password)
{
	int sockfd;
	struct hostent *he;
	struct sockaddr_in their_addr;
	char packet[1024];
	int size = 27;

	size += strlen(to);
	size += strlen(from);
	size += strlen(uid);
	size += strlen(message);
	size += strlen(password);

	snprintf(packet, 1012,
		 "POST /sms/sms.asp HTTP/1.1\nAccept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*\nContent-Type: application/x-www-form-urlencoded\nUser-Agent: TrustLab sms 0.99b\nHost: www.wildsms.com\nContent-Length: %d\nCache-Control: no-cache\n\nN=%s&UID=%s&O=%s&PW=%s&VER=2.01&M=%s\n",size, to, uid, from, password, message);
	size = 0;
	if ((he = gethostbyname(HOSTNAME)) == NULL)
	  {
		  herror("gethostbyname");
		  exit(1);
	  }

	their_addr.sin_family = AF_INET;
	their_addr.sin_port = htons(PORT);
	their_addr.sin_addr = *((struct in_addr *) he->h_addr);
	bzero(&(their_addr.sin_zero), 8);

	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	  {
		  perror("socket");
		  exit(1);
	  }

	if (connect (sockfd, (struct sockaddr *) &their_addr, sizeof(struct sockaddr)) == -1)
	  {
		  perror("connect");
		  exit(1);
	  }

	printf(GREEN "[*] Connecting ...");
	draw();
	printf(VIOLET "[*] Sending an sms to %s from %s..." WHITE1, to, from);
	draw();
	printf(RED "[*] Message: %s" WHITE1 "\n", message);
	

	if (send(sockfd, packet, strlen(packet), 0) == -1) {
		  perror("send");
		  exit(1);
	}

	close(sockfd);
	usleep(100);
	return 1;
}


void
split(char *msg)
{
	unsigned int l, i, j, c;

	l = strlen(msg);

	for (i = 0, j = 0, c = 0; c < NUM && i < l; i++)
	  {
		  msgs[c][j] = msg[i];

		  j++;
		  if (j == 160)
		    {
			    amount += 1;
			    j = 0;
			    c++;
		    }
	  }
	  
	printf(BLUE "[*] Going to send %d sms" WHITE1 "\n", amount);
												  
	
	printf("\nPress 'Y' to continue: ");
	if (getchar() != 'Y') {
	fprintf(stdout, "\n*** Exiting ***\n");
	exit(-1);
	}
				
}

void
draw(void)
{

	int p = 0;
	int k = 0;
	
	char try_ch[4] = "/-\\|";

	for (k = 0; k < 40; k++)
	  {

		  for (p = 0; p < 20;)
		    {
			    printf(YELLOW "\b%c" WHITE1, try_ch[(p%4)]);
			    fflush(stdout);
			    p++;
			    usleep(10);
			    k++;
		    }

	  }
		printf("\n");	
}


int check_balance(char *uid, char *pin)
{
	int sockfd;
	int credit;
    struct hostent *he;
	struct sockaddr_in their_addr;
		
	char pkt_balance[2048];
	int balance_size = 21;
	char resp[512];
	balance_size += strlen(uid);
	balance_size += strlen(pin);
	snprintf(pkt_balance, 2000,"POST /sms/sms.asp HTTP/1.1\nAccept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*\nContent-Type: application/x-www-form-urlencoded\nUser-Agent: TrustLab sms 0.99b\nHost: www.wildsms.com\nContent-Length: %d\nCache-Control: no-cache\nCookie: ASPSESSIONIDGQGGQMFK=JIGBLOGCMEINNGHLEIHCJMAB\n\nUID=%s&PW=%s&VER=2.01&N=?\n",balance_size, uid, pin);

	if ((he = gethostbyname(HOSTNAME)) == NULL)
	  {
		  herror("gethostbyname");
		  exit(1);
	  }

	their_addr.sin_family = AF_INET;
	their_addr.sin_port = htons(PORT);
	their_addr.sin_addr = *((struct in_addr *) he->h_addr);
	bzero(&(their_addr.sin_zero), 8);

	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	  {
		  perror("socket");
		  exit(1);
	  }

	if (connect (sockfd, (struct sockaddr *) &their_addr, sizeof(struct sockaddr)) == -1)
	  {
		  perror("connect");
		  exit(1);
	  }

	printf(GREEN "[*] Connecting... Checking amount of messages left for you...");
	draw();

	if (send(sockfd, pkt_balance, strlen(pkt_balance), 0) == -1)
	  {
		  perror("send");
		  exit(1);
	  }

	sleep(1);
	recv(sockfd, resp, sizeof(resp) - 1, 0);
	credit = credits(resp);
	printf("[*] You got " YELLOW "%i" WHITE1 " messages left\n", credit);
	printf(RED "\n[***] Done. <spam> visit http://www.motellmaffian.com </spam>" WHITE1 "\n");
	exit(1);
}


int
credits(char *str)
{
	char *str2;
	int c;

	str2 = strrchr(str, '\n');
	sscanf(str2, "%*[^,],%d,", &c);
	return c;
}


void usage(void) {
	printf(GREEN "Usage: " WHITE1 " -u username -p pincode <-b | -f from# -t to# -m 'this is my message'>\n");
	printf(GREEN "Ex1: " WHITE1 "./wildsms -u dude -p 1234 -b\n");
	printf(GREEN "Ex2: " WHITE1 "./wildsms -u dude -p 1234 -f FBI -t 46701234567 -m 'Hi :)'\n");

	exit(-1);
}


